; -----------------------------------------------------------------------------
; 680x0 Second Processor OS v1.00 (c) Eelco Huininga 2007
; DOS Filename   : bios.x68
; Load address   : 00000000
; Exec address   : 
; Length         : 00080000
; -----------------------------------------------------------------------------

DEBUG	SET 1

; Memory map:
; 00000000 - 0007FFFFF RAM (EEPROM at reset)
;   00000000 - 000003FF vectors
;   00000400 - 000004FF System variables
;   00000500 - 00007FFF User RAM
; 00080000 - 000EFFFFF EPROM (RAM at startup)

; ffff0000 - ffffffff i/o processors memory space


;
; D0[31..8]  Undetermined
; D0[7..0]   A
; D1[31..8]  Undetermined
; D1[7..0]   X
; D2[31..8]  Undetermined
; D2[7..0]   Y
;

prompt                                  EQU $2A		; Prompt
flash_rom_sectors			EQU $08		; Am29F040 has 8 sectors, 64k each
bios_address				EQU $FFF80000	; BIOS is at FFF80000 - FFFFFFFF


; -----------------------------------------------------------------------------
; TUBE ULA addresses
; -----------------------------------------------------------------------------

r1status                                EQU $00FE0000
r1data                                  EQU $00FE0001
r2status                                EQU $00FE0002
r2data                                  EQU $00FE0003
r3status                                EQU $00FE0004
r3data                                  EQU $00FE0005
r4status                                EQU $00FE0006
r4data                                  EQU $00FE0007


; -----------------------------------------------------------------------------
; Start of code
; -----------------------------------------------------------------------------

START ORG $00000000
vector_table
	                                          ; CPU Reset vectors
	DC.L    $00008000                         ;   0: Initial stack pointer (Top of RAM; in this example RAM would go from 0000 to 1FFF)
	DC.L    reset_entry                       ;   1: Initial program counter (start address)
	                                          ; CPU Exception vectors
	DC.L    exception_handler                 ;   2: Bus error
	DC.L    exception_handler                 ;   3: Address error
	DC.L    unknown_interrupt                 ;   4: Illegal instruction
	DC.L    unknown_interrupt                 ;   5: Integer divide-by-zero
	DC.L    unknown_interrupt                 ;   6: CHK, CHK2 instruction
	DC.L    unknown_interrupt                 ;   7: FTRAPcc, TRAPcc, TRAPV instruction
	DC.L    unknown_interrupt                 ;   8: Privilege violation
	DC.L    unknown_interrupt                 ;   9: Trace
	DC.L    unknown_interrupt                 ;  10: Line 1010 emulator (unimplemented A-line opcode)
	DC.L    unknown_interrupt                 ;  11: Line 1111 emulator (unimplemented F-line opcode) / Floating-point unimplemented instruction / Floating-point disabled
	DC.L    unknown_interrupt                 ;  12: Emulator interrupt (MC68060 only)
	DC.L    unknown_interrupt                 ;  13: Coprocessor Protocol Violation (MC68020 & MC68030 only)
	DC.L    unknown_interrupt                 ;  14: Format Error ( >= MC68010)
	DC.L    unknown_interrupt                 ;  15: Uninitialized interrupt vector
	DC.L    unknown_interrupt                 ;  16: (reserved)
	DC.L    unknown_interrupt                 ;  17: (reserved)
	DC.L    unknown_interrupt                 ;  18: (reserved)
	DC.L    unknown_interrupt                 ;  19: (reserved)
	DC.L    unknown_interrupt                 ;  20: (reserved)
	DC.L    unknown_interrupt                 ;  21: (reserved)
	DC.L    unknown_interrupt                 ;  22: (reserved)
	DC.L    unknown_interrupt                 ;  23: (reserved)
	DC.L    unknown_interrupt                 ;  24: Spurious Interrupt (Bus error during interrupt)
	                                          ; Auto-vector interrupts
	DC.L    unknown_interrupt                 ;  25: Level-1 autovector (INT1)
	DC.L    unknown_interrupt                 ;  26: Level-2 autovector (INT2)
	DC.L    unknown_interrupt                 ;  27: Level-3 autovector (INT3)
	DC.L    unknown_interrupt                 ;  28: Level-4 autovector (INT4)
	DC.L    irq_handler                       ;  29: Level-5 autovector (INT5) TUBE ULA IRQ
	DC.L    unknown_interrupt                 ;  30: Level-6 autovector (INT6)
	DC.L    nmi_handler                       ;  31: Level-7 autovector (INT7) TUBE ULA NMI
	                                          ; TRAP instruction vectors
	DC.L    unknown_interrupt                 ;  32: TRAP 0 vector (OS/9 system call)
	DC.L    unknown_interrupt                 ;  33: TRAP 1 vector
	DC.L    unknown_interrupt                 ;  34: TRAP 2 vector
	DC.L    unknown_interrupt                 ;  35: TRAP 3 vector
	DC.L    unknown_interrupt                 ;  36: TRAP 4 vector
	DC.L    unknown_interrupt                 ;  37: TRAP 5 vector
	DC.L    unknown_interrupt                 ;  38: TRAP 6 vector
	DC.L    unknown_interrupt                 ;  39: TRAP 7 vector
	DC.L    unknown_interrupt                 ;  40: TRAP 8 vector
	DC.L    unknown_interrupt                 ;  41: TRAP 9 vector
	DC.L    unknown_interrupt                 ;  42: TRAP 10 vector
	DC.L    unknown_interrupt                 ;  43: TRAP 11 vector
	DC.L    unknown_interrupt                 ;  44: TRAP 12 vector
	DC.L    unknown_interrupt                 ;  45: TRAP 13 vector (OS/9 CIO: is automatically called for any C program)
	DC.L    SWI_Handler                       ;  46: TRAP 14 vector
	DC.L    unknown_interrupt                 ;  47: TRAP 15 vector (OS/9 Math is called for floating point math, extended integer math and/or type conversion. It is also used for programs using transcendental and/or extended mathematical functions.)
	DC.L    unknown_interrupt                 ;  48: FPU: Branch or Set on Unordered Condition
	DC.L    unknown_interrupt                 ;  49: FPU: Inexact Result
	DC.L    unknown_interrupt                 ;  50: FPU: Divide by Zero
	DC.L    unknown_interrupt                 ;  51: FPU: Underflow
	DC.L    unknown_interrupt                 ;  52: FPU: Operand Error
	DC.L    unknown_interrupt                 ;  53: FPU: Overflow
	DC.L    unknown_interrupt                 ;  54: FPU: Signaling NAN (Not-A-Number)
	DC.L    unknown_interrupt                 ;  55: FPU: Unimplemented data type (MC68040 & MC68060 only)
	DC.L    unknown_interrupt                 ;  56: MMU: Configuration Error (MC68030 & MC68851 only)
	DC.L    unknown_interrupt                 ;  57: MMU: Illegal Operation Error (MC68851 only)
	DC.L    unknown_interrupt                 ;  58: MMU: Access Level Violation Error (MC68851 only)
	                                          ; Miscellaneous vectors
	DC.L    unknown_interrupt                 ;  59: (reserved)
	DC.L    unknown_interrupt                 ;  60: FPU: Unimplemented effective address (MC68060 only)
	DC.L    unknown_interrupt                 ;  61: Unimplemented integer instruction (MC68060 only)
	DC.L    unknown_interrupt                 ;  62: (reserved)
	DC.L    unknown_interrupt                 ;  63: (reserved)
	                                          ;  64-255: user (acknowledged) interrupt vectors

; -----------------------------------------------------------------------------
; OS workspace
; -----------------------------------------------------------------------------
	ORG     $00000400
os_workspace
	                                          ; Acorn vectors
userv	DC.L    not_supported                     ; $00000400 USERV (Not implemented)                   
brkv	DC.L    _brkv                             ; $00000404 BRKV                                      
irq1v	DC.L    _irq1v                            ; $00000408 IRQ1V                                     
irq2v	DC.L    not_supported                     ; $0000040C IRQ2V (Not implemented)                   
cliv	DC.L    _oscli                            ; $00000410 CLIV                                      
bytev	DC.L    _osbyte                           ; $00000414 BYTEV (TUBE ULA Data register 2 = &04/&06)
wordv	DC.L    _osword                           ; $00000418 WORDV (TUBE ULA Data register 2 = &08/&0A)
wrchv	DC.L    _oswrch                           ; $0000041C WRCHV                                     
rdchv	DC.L    _osrdch                           ; $00000420 RDCHV (TUBE ULA Data register 2 = &02)    
filev	DC.L    _osfile                           ; $00000424 FILEV (TUBE ULA Data register 2 = &14)    
argsv	DC.L    _osargs                           ; $00000428 ARGSV (TUBE ULA Data register 2 = &0C)    
bgetv	DC.L    _osbget                           ; $0000042C BGETV (TUBE ULA Data register 2 = &0E)    
bputv	DC.L    _osbput                           ; $00000430 BPUTV (TUBE ULA Data register 2 = &10)    
gbpbv	DC.L    _osgbpb                           ; $00000434 GBPBV (TUBE ULA Data register 2 = &16)    
findv	DC.L    _osfind                           ; $00000438 FINDV (TUBE ULA Data register 2 = &12)    
fscv	DC.L    not_supported                     ; $0000043C FSCV (Not implemented)                    
evntv	DC.L    _evntv                            ; $00000440 EVNTV (RTS; Does nothing)                 
uptv	DC.L    not_supported                     ; $00000444 UPTV (Not implemented)                    
netv	DC.L    not_supported                     ; $00000448 NETV (Not implemented)                    
vduv	DC.L    not_supported                     ; $0000044C VDUV (Not implemented)                    
keyv	DC.L    not_supported                     ; $00000450 KEYV (Not implemented)                    
insv	DC.L    not_supported                     ; $00000454 INSV (Not implemented)                    
remv	DC.L    not_supported                     ; $00000458 REMV (Not implemented)                    
cnpv	DC.L    not_supported                     ; $0000045C CNPV (Not implemented)                    
ind1v	DC.L    _ind1v                            ; $00000460 IND1V (RTS; Does nothing)                 
ind2v	DC.L    _ind2v                            ; $00000464 IND2V (RTS; Does nothing)                 
ind3v	DC.L    _ind3v                            ; $00000468 IND3V (RTS; Does nothing)                 

	                                          ; OS variables
himem	DC.L    $00007E00                         ; $0000046c HIMEM; this leaves 512 bytes for the stack
oshwm	DC.L    $00000600                         ; $00000470 OSHWM; Reserve page 4 and 5 for the OS
ramsize	DC.L    $00000000                         ; $00000474 RAMSIZE; Total size of RAM available
error	DC.L    $00000000                         ; $00000478 Pointer to last generated error
langrom	DC.L    $00000000                         ; $0000047C Pointer to start of language ROM
hoaddr	DC.W    $0000                             ; $00000480 High order pointer
cputype	DC.B	$00                               ; $00000482 CPU type ($01=68008, $02=68000, $03=68010, $04=68020, $05=68030, $06=68040, $07=68060, $FF=unknown CPU)
fputype	DC.B	$00                               ; $00000483 FPU type ($00=no FPU, $01=68881, $02=68882, $03=CPU integrated(68040/68060), $FF=unknown FPU)
mmutype	DC.B	$00                               ; $00000484 MMU type ($00=no MMU, $01=68841, $02=68851, $03=CPU integrated(68030/68040/68060), $FF=unknown MMU)

buffer	ORG     $00000500                         ; OSWORD &00 and OSCLI buffer

	ORG     $FFF00600                         ; RAM at $00000000 is enabled when A31 is asserted
; -----------------------------------------------------------------------------
; Reset entry
; -----------------------------------------------------------------------------
reset_entry
	OR.B #$FF, r1status
	OR.B #$FF, r2status
	OR.B #$FF, r3status
	OR.B #$FF, r4status

	MOVE.B  r2data, D0                        ; Enable RAM

init_ram
	MOVE.W  #255, D0                          ; Number of system vectors minus one
	MOVE.L  #$00000000, A0                    ; Destination address
	MOVE.L  #vector_table, A1                 ; Source address

init_ram1
	MOVE.L  (A1)+, (A0)+                      ; Move data
	DBF     D0, init_ram1

	MOVE.W  #63, D0                           ; Number of words minus one
	MOVE.L  #$00000400,  A0                   ; Destination address
	MOVE.L  #os_workspace,  A1                ; Source address

init_ram2
	MOVE.L  (A1)+, (A0)+                      ; Move data
	DBF     D0, init_ram2


	BSR     check_cpu                         ; Find out which CPU is present
	MOVE.B  D0, cputype                       ; ...and store it
	BSR     check_fpu                         ; Find out which FPU is present
	MOVE.B  D0, fputype                       ; ...and store it
	BSR     check_mmu                         ; Find out which MMU is present
	MOVE.B  D0, mmutype                       ; ...and store it

	                                          ; Print the startup message
	MOVE.L  #startup_message, A6              ; Location of message in A6
	BSR     print_message                     ; Print the message

	BSR     read_from_r2data                  ; 
	CMP.B   #$80, D0                          ; 
	BEQ     enter_language_rom                ; Check copyright message and ROM type and enter language ROM

main_loop
	MOVE.B  #prompt, D0                       ; * Prompt
	BSR     oswrch

	MOVE.L  #osword_00_parameterblock, A6     ; A6 points to OSWORD &00 parameter block
	MOVEQ   #$00, D0                          ; OSWORD &00: Read line from input
	BSR     osword
	BCS     escape                            ; Jump if user pressed ESCAPE

	MOVE.L  #buffer, A6                       ; A6 points to the line read by the OSWORD &00 call
	BSR     oscli
	BRA     main_loop                         ; Loop infinitely
escape
	MOVEQ   #$7E, D0                          ; OSBYTE $7E: Acknowledge detection of an ESCAPE condition
	BSR     osbyte
	MOVE.L  #escape_error, A6                 ; Point A6 to the ESCAPE error message
	MOVEQ   #OS_GenerateError, D0
	TRAP    #14                               ; Generate error
	BRA     main_loop                         ; This command should never be reached

; -----------------------------------------------------------------------------
; Check copyright message and ROM type and enter language ROM
; -----------------------------------------------------------------------------
enter_language_rom
;	MOVE.B  (langrom)+7, D0
;	LEA     (langrom), A6
	
	BRA     main_loop

; -----------------------------------------------------------------------------
; Print message to output stream
; -----------------------------------------------------------------------------
print_message
	MOVE.B  (A6)+, D0                         ; Get byte in D0
	BEQ     exit_print_message                ; Exit if it's the last byte
	BSR     oswrch                            ; Print byte
	BRA     print_message                     ; And get the next one
	
exit_print_message
	RTS

; -----------------------------------------------------------------------------
; Reset/Bus error/Address error exception handler
; -----------------------------------------------------------------------------
exception_handler
	MOVE.W  (A7)+, A6                         ; Pop "Memory access type and function code" word
	MOVE.L  (A7)+, A6                         ; Pop "Access address" long
	MOVE.W  (A7)+, A6                         ; Pop "Instruction register" word
	MOVE.W  (A7)+, A6                         ; Pop "Status register" word
	MOVE.L  (A7)+, A6                         ; Pop "Program counter" long

exception0handler2
	BRA     exception0handler2

; -----------------------------------------------------------------------------
; 
; -----------------------------------------------------------------------------
exception1_handler
	RTE

; -----------------------------------------------------------------------------
; Wait for data in TUBE ULA Data register 2 and return it in A
; -----------------------------------------------------------------------------
read_from_r2data
	BTST    #7, r2status                      ; Check the DA2 flag of TUBE ULA Status register 2 (Data present in 2st register)
	BEQ     read_from_r2data                  ; No? Then wait
	MOVE.B  r2data, D0                        ; D0.B = ?r2data
	RTS

; -----------------------------------------------------------------------------
; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
; -----------------------------------------------------------------------------
write_to_r2data
	BTST    #6, r2status                      ; Check the NF2 flag of TUBE ULA Status register 2 (2nd data register not filled)
	BEQ     write_to_r2data                   ; Loop until TUBE ULA Data register 2 is empty
	MOVE.B  D0, r2data                        ; Write byte to r2data
	RTS

; -----------------------------------------------------------------------------
; Send string at (A6) through TUBE ULA Data register 2
; -----------------------------------------------------------------------------
write_string_to_r2data
	MOVE.B  (A6)+, D0                         ; Get byte in D0
	BSR     write_to_r2data
	CMP.B   #$0D, D0                          ; Is it the last character in the string?
	BNE     write_string_to_r2data            ; No? Then process next character
	RTS

; -----------------------------------------------------------------------------
; BRKV: BRK handler
; -----------------------------------------------------------------------------
_brkv
	RTS

; -----------------------------------------------------------------------------
; Error handler
; -----------------------------------------------------------------------------

OS_GenerateError
	BSR     osnewl
	BSR     print_message                     ; Print error message at (A6)
	BSR     osnewl
	MOVE.L  ($00000000), SP                   ; Reset stack pointer
	BRA     main_loop                         ; Return to the prompt


; -----------------------------------------------------------------------------
; OSWORD &00 parameter block
; -----------------------------------------------------------------------------
osword_00_parameterblock
	DC.L    buffer                            ; Buffer address at $00000500
	DC.B    255                               ; Maximum line length is 255
	DC.B    $20                               ; Minimum acceptable ASCII value
	DC.B    $FF                               ; Maximum acceptable ASCII value

	DC.B    0                                 ; Align to words

; -----------------------------------------------------------------------------
; Loop until (A6) isn't ASCII value 32 (space)
; -----------------------------------------------------------------------------
find_next_non_space
	CMP.B   #' ', (A6)+                       ; Is it ASCII value 32 (space)?
	BEQ     find_next_non_space               ; No? Then check next byte
	MOVE.B  -(A6), D0                         ; Put the first non-SPACE character in D0
	RTS

; -----------------------------------------------------------------------------
; Return hex value of string at (A6) in D1
; -----------------------------------------------------------------------------
get_hex_value
	CLR     D1                                ; Clear contents of D1

get_hex_value1
	MOVE.B  (A6)+, D0                         ; Get byte in D0
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack

	CMP.B   #'0', D0
	BLO     get_hex_value3                    ; Invalid character
	CMP.B   #'9', D0
	BLS     get_hex_value2                    ; Character is between 0-9, so process it now

	ANDI.B  #%11011111, D0                    ; Make character upper-case
	CMP.B   #'A', D0
	BLO     get_hex_value3                    ; Invalid character
	CMP.B   #'F', D0
	BHI     get_hex_value3                    ; Invalid character
	SUBI.B  #$07, D0

get_hex_value2
	ANDI.B  #%00001111, D0                    ; Mask out the highest nibble
	ASL.L   #4, D1                            ; Shift D1 to make room for new nibble
	ADD.B   D0, D1                            ; Add the nibble to the result

	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack (not used; just to clean things up)
	BRA     get_hex_value1

get_hex_value3
	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack

	CMP.B   #$0D, D0                          ; Is the next character CR?
	BEQ     get_hex_value4                    ; Yes? Then exit with C=0

	CMP.B   #' ', D0                          ; Is the next character SPACE?
	BEQ     get_hex_value4                    ; Yes? Then exit with C=0

	SUBQ    #1, A6                            ; Optimize?
	ORI     #%00001, CCR                      ; Set the carry bit and exit
	RTS

get_hex_value4
	SUBQ    #1, A6                            ; Optimize?
	ANDI    #%11110, CCR                      ; Clear the carry-bit and exit
	RTS

; -----------------------------------------------------------------------------
; OSWRCH: Write D0.B character to output stream
; -----------------------------------------------------------------------------
_oswrch
	MOVE.L  D0, -(A7)
	MOVE.L  D1, -(A7)
	MOVE.B  D0, D1
	MOVE.B  #6, D0
	TRAP    #14
	MOVE.L  (A7)+, D1                         ; Pull D0 from the stack
	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	RTS

	BTST    #6, r1status                     ; Check the NF1 flag of TUBE ULA Status register 1 (1st data register not filled)
	BEQ     _oswrch                          ; Loop until TUBE ULA Data register 2 is empty
	MOVE.B  D0, r1data                       ; ?r1data = D0.B
	RTS

; -----------------------------------------------------------------------------
; OSRDCH: Read character from input stream
; -----------------------------------------------------------------------------
_osrdch
	MOVE.B  #5, D0
	TRAP    #14
	MOVE.B  D1, D0
	RTS

	MOVEQ   #$00, D0
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

_osrdch1
	BSR     read_from_r2data                  ; Wait for data in TUBE ULA Data register 2 and return it in A
	ASR.B   #8, D0                            ; Move bit 7 to carry flag
	BRA     read_from_r2data                  ; And get the last byte

; -----------------------------------------------------------------------------
; OSARGS: Read or write a file's attributes
; -----------------------------------------------------------------------------
_osargs
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	MOVE.B  #$0C, D0                          ; Code $0C for OSARGS
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	MOVE.B  D2, D0                            ; File handle
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	MOVE.L  #$03, D2                          ; Send the 3-byte control block to the host
_osargs1
	MOVE.B  (A6, D2), D0
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	DBEQ    D2, _osargs1

	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack (function)
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	BSR     read_from_r2data                  ; Wait for data in TUBE ULA Data register 2 and return it in A
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack (result)

	MOVE.L  #$03, D2                          ; Receive the 3-byte control block from the host
_osargs2
	BSR     read_from_r2data                  ; Wait for data in TUBE ULA Data register 2 and return it in A
	MOVE.B  D0, (A6, D2)
	DBEQ    D2, _osargs2

	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	RTS

; -----------------------------------------------------------------------------
; OSBGET: Read a single byte from an open file
; -----------------------------------------------------------------------------
_osbget
	MOVE.B  #$0E, D0                          ; Code $0E for BGET
	JSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	MOVE.B  D2, D0                            ; File handle
	JSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	BRA     _osrdch1                          ; Get carry bit and the byte read

; -----------------------------------------------------------------------------
; OSBPUT: Write a single byte to an open file
; -----------------------------------------------------------------------------
_osbput
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	MOVE.B  #$10, D0                          ; Code $10 for OSBPUT
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	MOVE.B  D2, D0                            ; File handle
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	BSR     read_from_r2data                  ; Wait for data in TUBE ULA Data register 2 and return it in A
	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	RTS

; -----------------------------------------------------------------------------
; OSFIND: Open or close a file for random or sequential access
; -----------------------------------------------------------------------------
_osfind
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	MOVE.B  #$12, D0                          ; Code $12 for OSFIND
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	TST     D0                                ; Should the file be closed? (result = $00)
	BNE     _osfind2
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	MOVE.B  D2, D0                            ; File handle
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	BSR     read_from_r2data                  ; Wait for data in TUBE ULA Data register 2 and return it in A
	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	RTS
_osfind2
	BSR     write_string_to_r2data            ; Send string at (A6) through TUBE ULA Data register 2
	BRA     read_from_r2data                  ; Wait for data in TUBE ULA Data register 2 and return it in A

; -----------------------------------------------------------------------------
; OSFILE: Read or write a whole file or its attributes
; -----------------------------------------------------------------------------
_osfile
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	MOVE.B  #$14, D0                          ; Code $14 for OSFILE
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	MOVE.L  #$0F, D2
_osfile2
	MOVE.B  $02(A6,D2), D0                    ; Send XY+17 to XY+2 to the host
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	DBEQ    D2, _osfile2

	MOVE.L  A6, -(A7)                         ; Push A6 to the stack
	MOVE.L  A6, (A6)                          ; Points to the location of the filename
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	BSR     write_string_to_r2data            ; Send string at (A6) through TUBE ULA Data register 2
	MOVE.L  (A7)+, A6                         ; Pull A6 from the stack

	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	BSR     read_from_r2data                  ; Wait for data in TUBE ULA Data register 2 and return it in A
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack (result code)

	MOVE.L  #$0F, D2
_osfile3
	BSR     read_from_r2data                  ; Wait for data in TUBE ULA Data register 2 and return it in A
	MOVE.B  D0, $02(A6,D2)                    ; Read the resulting parameter block and put it at XY
	DBEQ    D2, _osfile3

	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	RTS

; -----------------------------------------------------------------------------
; OSGBPB handler
; -----------------------------------------------------------------------------
_osgbpb
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	MOVE.B  #$16, D0                          ; Code $16 for OSGBPB
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	MOVE.L  #$0C, D2
_osgbpb1
	MOVE.B  (A6,D2), D0                       ; Send parameterblock to the host
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	DBEQ    D2, _osgbpb1

	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	MOVE.L  #$0C, D2
_osgbpb2
	BSR     read_from_r2data                  ; Wait for data in TUBE ULA Data register 2 and return it in A
	MOVE.B  D0, (A6,D2)                       ; Send parameterblock to the host
	DBEQ    D2, _osgbpb2

	BRA     _osrdch1                          ; Get carry bit and the byte read

; -----------------------------------------------------------------------------
; OSBYTE handler
; -----------------------------------------------------------------------------
_osbyte
	CMP.B   #$80, D0
	BHS     _osbyte1

	MOVE.L  D0, -(A7)                         ; Push D0 to the stack

	MOVE.B  #$04, D0                          ; Code $04 for OSBYTE $00-$7F
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	MOVE.B  D1, D0                            ; Send X value to the host
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	BSR     read_from_r2data                  ; Wait for data in TUBE ULA Data register 2 and return it in A
	MOVE.B  D0, D1                            ; Set D1 to the new X value received from the host
	RTS

_osbyte1
	CMP.B   #$82, D0                          ; Is it OSBYTE $82? (Read machine high order address)
	BEQ     osbyte_82
	CMP.B   #$83, D0                          ; Is it OSBYTE $83? (Read top of operating system RAM address (OSHWM)
	BEQ     osbyte_83
	CMP.B   #$84, D0                          ; Is it OSBYTE $84? (Read bottom of display RAM address (HIMEM)
	BEQ     osbyte_84

	MOVE.L  D0, -(A7)                         ; Push D0 to the stack

	MOVE.B  #$06, D0                          ; Code $06 for OSBYTE $80-$81, $85-$FF
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	MOVE.B  D1, D0                            ; Send X value to the host
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	MOVE.B  D2, D0                            ; Send Y value to the host
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	CMP.B   #$8E, D0                          ; Is it OSBYTE $8E? (Enter language ROM)
	BEQ     enter_language_rom

	CMP.B   #$9D, D0                          ; Is it OSBYTE $9D? (Fast TUBE BPUT)
	BEQ     osbyte_9D

	MOVE.L  D0, -(A7)                         ; Push D0 to the stack

	BSR     read_from_r2data                  ; Wait for data in TUBE ULA Data register 2 and return it in A
	ASR.B   #8, D0                            ; Move bit 7 to carry flag

	BSR     read_from_r2data                  ; Wait for data in TUBE ULA Data register 2 and return it in A
	MOVE.B  D0, D2                            ; Set D2 to the new Y value received from the host

	BSR     read_from_r2data                  ; Wait for data in TUBE ULA Data register 2 and return it in A
	MOVE.B  D0, D1                            ; Set D1 to the new X value received from the host

	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	RTS


; -----------------------------------------------------------------------------
; OSBYTE $9D handler (Fast TUBE BPUT)
; -----------------------------------------------------------------------------
osbyte_9D
	RTS

; -----------------------------------------------------------------------------
; OSBYTE $84 handler (Read bottom of display RAM address: HIMEM)
; -----------------------------------------------------------------------------
osbyte_84
	MOVE.L  (himem), D1
	RTS

; -----------------------------------------------------------------------------
; OSBYTE $83 handler (Read top of operating system RAM address: OSHWM)
; -----------------------------------------------------------------------------
osbyte_83
	MOVE.L  (oshwm), D1
	RTS

; -----------------------------------------------------------------------------
; OSBYTE $82 handler (Read machine high order address)
; -----------------------------------------------------------------------------
osbyte_82
	MOVE.W  (hoaddr), D1
	RTS

; -----------------------------------------------------------------------------
; OSWORD handler
; -----------------------------------------------------------------------------
_osword
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	TST     D0                                ; Is it OSWORD &00: Read line from input stream?
	BEQ     osword_00                         ; Yes? Then jump

	MOVE.B  #$08, D0                          ; Code &08 for OSWORD &01-&FF calls
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	CMP.B   #$80, D0
	BLO     osword_017F                       ; Jump if it's an OSWORD $01-$7F call

	MOVE.B  (A6), D1                          ; Length of parameter block to be send
	BRA     osword1
;FB20  A8           .     TAY
;FB21  4C 2D FB     L-.   JMP &FB2D

osword_017F
	MOVE.B  (osword_send_table.D0)-1, D1        ; Get the length of the parameterblock from the table for OSWORD &01-&14
	CMP.B   #$15, D0
	BLO     osword1
	MOVE.B  #$10, D1                          ; Set length of the parameterblock to &10 for OSWORD &15-&7F

osword1
	MOVE.B  D1, D0                            ; Send length of parameter block to the host processor
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	DBF     D1, osword3                       ; Jump if no parameters are to be sended

osword2
	MOVE.B  (A6, D1), D0                      ; Send the parameter block to the host processor
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	DBF     D1, osword2

osword3
	CMP.B   #$80, D0
	BHI     osword4                           ; Jump if it's an OSWORD $01-$7F call

	MOVE.B  (A6), D1                          ; Length of parameterblock to be received
;inc d1
	BRA     osword5

osword4
	MOVE.B  (osword_recv_table.D0)-1, D1      ; Get the length of the parameterblock from the table for OSWORD &01-&14
	CMP.B   #$15, D0
	BLO     osword5
	MOVE.B  #$10, D1                          ; Set length of the parameterblock to &10 for OSWORD &15-&7F

osword5
	MOVE.B  D1, D0                            ; Send length of parameter block to the host processor
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	DBF     D1, osword7                       ; Jump if no parameters are to be sended

osword6
	BSR     read_from_r2data                  ; Get the parameter and store it in the parameterblock
	MOVE.B  D0, (A6, D1)
	DBF     D1, osword6

osword7
	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	RTS

; -----------------------------------------------------------------------------
; OSWORD $00 handler
; -----------------------------------------------------------------------------
osword_00
	MOVE.L  (A7)+, D0                         ; ... and restore D0 to $00
	MOVE.B  #2, D0
	MOVE.L  (A6), A1
	TRAP    #14
	ADD.W   D1, A1
	MOVE.B  #13, (A1)
	RTS


	MOVE.B  #$0A, D0                          ; Code &0A for OSWORD &00 call
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	MOVE.B  6(A6), D0                         ; Send parameter 6 (Maximum allowable ASCII value)
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	MOVE.B  5(A6), D0                         ; Send parameter 5 (Minimum allowable ASCII value)
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	MOVE.B  4(A6), D0                         ; Send parameter 4 (Maximum length)
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	MOVE.B  #$07, D0                          ; Code ??
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2
	MOVE.B  #$00, D0                          ; Code ??
	BSR     write_to_r2data                   ; Wait for TUBE ULA Data register 2 to be clear and send A to Data register 2

	BSR     read_from_r2data                  ; Get the parameter and store it in the parameterblock
	CMP.B   #$80, D0
	BEQ     osword_00_escape

	MOVE.L  (A6), A5                          ; Get the buffer address

osword_00_loop
	BSR     read_from_r2data                  ; Get the parameter and store it in the parameterblock
	MOVE.B  D0, (A5)+                         ; Store byte in buffer
	CMP.B   #$0D, D0
	BNE     osword_00_loop

	SUB.L   (A6), A5                          ; Substract last buffer position with first buffer position to calculate the length of the string received
	MOVE.L  A5, D2                            ; ...and put it in D2
	MOVEQ   #$00, D1                          ; Set D1 to 0 (ESCAPE wasn't pressed)
	MOVE.L  (A7)+, D0                         ; ... and restore D0 to $00
	ANDI    #%11110, CCR                      ; Clear the carry-bit and exit
	RTS

osword_00_escape
	                                          ; ESCAPE was pressed, so exit with carry set and X = &FF
	MOVE.L  (A7)+, D0                         ; ... and restore D0 to $00
	MOVEQ   #$FF, D1                          ; Set D1 to $FF (ESCAPE was pressed)
	ORI     #%00001, CCR                      ; Set the carry bit and exit
	RTS

; -----------------------------------------------------------------------------
; OSCLI handler
; -----------------------------------------------------------------------------
_oscli
	BSR     find_next_non_space               ; Find first non-space character
	MOVE.L  A6, -(A7)                         ; Push A6 to the stack
	MOVE.B  (A6)+, D0
	CMP.B   #prompt, D0
	BEQ     _oscli
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #'F', D0                          ; Is it *G(O)?
	BEQ     flash
	CMP.B   #'G', D0                          ; Is it *G(O)?
	BEQ     go
	CMP.B   #'H', D0                          ; Is it *H(ELP)?
	BEQ     help
	CMP.B   #'M', D0                          ; Is it *M(ON)?
	BEQ     mon
	CMP.B   #'S', D0                          ; Is it *S?
	BEQ     s
	CMP.B   #'X', D0                          ; Is it *X(FER)?
	BEQ     xfer
_oscli1
	MOVEQ   #$02, D0                          ; 
	BSR     write_to_r2data
	MOVE.L  (A7)+, A6                         ; Pop A6 from the stack
	BSR     write_string_to_r2data            ; Send string to the host
	BSR     read_from_r2data                  ; Get response from the host
	CMP.B   #$80, D0
	BEQ     enter_language_rom2
	RTS

; -----------------------------------------------------------------------------
; *FLASH
; -----------------------------------------------------------------------------
flash
	MOVE.B  (A6)+, D0
	CMP.B   #'.', D0                          ; Is it .?
	BEQ     help2
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #'L', D0                          ; Is it L?
	BNE     _oscli1
	MOVE.B  (A6)+, D0
	CMP.B   #'.', D0                          ; Is it .?
	BEQ     help2
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #'A', D0                          ; Is it A?
	BNE     _oscli1
	MOVE.B  (A6)+, D0
	CMP.B   #'.', D0                          ; Is it .?
	BEQ     help2
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #'S', D0                          ; Is it S?
	BNE     _oscli1
	MOVE.B  (A6)+, D0
	CMP.B   #'.', D0                          ; Is it .?
	BEQ     help2
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #'H', D0                          ; Is it H?
	BNE     _oscli1
flash2
	BSR     find_next_non_space               ; Loop until (A6) isn't ASCII value 32 (space)
	BSR     get_hex_value                     ; Return hex value of string at (A6) in D1
	BCS     flash_help                        ; Jump if the parameter wasn't valid

	CMP.B   #flash_rom_sectors, D1            ; Check if sector is < 8
	BHS     flash_help                        ; If not, print help message

	MOVE.L  D1, D7                            ; Move sector to D7

	BSR     find_next_non_space               ; Loop until (A6) isn't ASCII value 32 (space)
	BSR     get_hex_value                     ; Return hex value of string at (A6) in D1
	BCS     flash_help                        ; Jump if the parameter wasn't valid
	MOVE.L  D1, D6                            ; Move address to D6

	MOVE.L  #flash_warning, A6                ; Print flash warning
	BSR     print_message

	MOVEQ   #$15, D0                          ; *FX 21,0 (Flush keyboard buffer)
	MOVEQ   #$00, D1
	BSR     osbyte

	BSR     osrdch                            ; Read one character from the input stream
	ANDI.B  #%11011111, D0                    ; Make character upper-case
	CMP.B   #'Y', D0                          ; Is it 'Y'?
	BNE     flash_exit
	JSR     oswrch

; Since the BIOS won't be available when the flash ROM is switched to command mode, this code must be relocated to RAM
;	MOVE.L  #flash_identify_message, A6       ; Print ID message
;	BSR     print_message
;	BSR     flash_identify
;	BSR     dump_d0                           ; Print device id

	MOVE.L  #flash_start_message, A6          ; Print flashing sector
	BSR     print_message
	MOVE.B  D7, D0
	ADD.B   #'0', D0
	BSR     oswrch
	BSR     osnewl

	MOVE.L  #flash_finish_message, A6         ; Location of message in A0
	BSR     print_message
	BRA     flash_exit

flash_error
	MOVE.L  #flash_error_message, A6          ; Location of message in A0
	BSR     print_message

flash_exit
	RTS

; -----------------------------------------------------------------------------
; Resets the flash ROM to data mode
; -----------------------------------------------------------------------------
flash_reset
	MOVE.B  #$F0, bios_address
	MOVE.B  #$FF, bios_address
	RTS	

; -----------------------------------------------------------------------------
; Returns the flash ROM's vendor and device ID in D0
; -----------------------------------------------------------------------------
flash_identify
	MOVE.B  #$AA, bios_address+$5555          ; Switch flash ROM to command mode
	MOVE.B  #$55, bios_address+$AAAA
	MOVE.B  #$90, bios_address+$5555          ; Read identification command
	MOVE.B  D0, bios_address                  ; Get vendor ID
	ASL.W   #8, D0                            ; Shift D0 to make room for device ID
	BSR     flash_reset

	MOVE.B  #$AA, bios_address+$5555          ; Switch flash ROM to command mode
	MOVE.B  #$55, bios_address+$AAAA
	MOVE.B  #$90, bios_address+$5555          ; Read identification command
	MOVE.B  D0, bios_address+1                ; Get device ID
	BSR     flash_reset

	RTS

; -----------------------------------------------------------------------------
; Writes one sector (65536 bytes) in the flash ROM (D7=sector, A6=memory address)
; -----------------------------------------------------------------------------
flash_write_sector
	CMP.B   #flash_rom_sectors, D7            ; Check if sector is < 8
	BHS     flash_write_sector99              ; If not, exit
	ASL.W   #16, D7

	MOVE.L  #$FFFF, D1                        ; 65536-1 bytes

flash_write_sector1
	MOVE.B  (A5), D0                          ; Get byte from memory
	BSR     flash_write_byte
;;;;;;
	DBF     D2, shift_wo                      ; Do next nibble

flash_write_sector99
	RTS

; -----------------------------------------------------------------------------
; Writes one byte in the flash ROM
; -----------------------------------------------------------------------------
flash_write_byte
	CMP.B   D0, (A6)                          ; Check if the address already contains this byte
	BEQ     flash_write_byte2                 ; Yes? Then exit

	MOVE.B  #$AA, bios_address+$5555          ; Switch flash ROM to command mode
	MOVE.B  #$55, bios_address+$AAAA
	MOVE.B  #$A0, bios_address+$5555          ; Read identification command
	MOVE.B  (A6), D0                          ; Write byte

flash_write_byte1
	CMP.B   #2, (A6)
	BNE     flash_write_byte1

	BSR     flash_reset

flash_write_byte2
	RTS

; -----------------------------------------------------------------------------
; *GO Syntax error
; -----------------------------------------------------------------------------
flash_help
	MOVE.L  #flash_help_message, A6           ; Location of message in A0
	BSR     print_message
	MOVE.L  (A7)+, A6                         ; Pop A6 from the stack
	RTS

; -----------------------------------------------------------------------------
; *GO
; -----------------------------------------------------------------------------
go
	MOVE.B  (A6)+, D0
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #$4F, D0                          ; Is it O?
	BNE     _oscli1
	MOVE.B  (A6)+, D0                         ; Get the next character
	CMP.B   #$20, D0                          ; Is it SPACE?
	BNE     _oscli1

	BSR     find_next_non_space               ; Loop until (A6) isn't ASCII value 32 (space)
	BSR     get_hex_value                     ; Return hex value of string at (A6) in D1
	BCS     go_help                           ; Jump if the parameter wasn't valid

	BSR     find_next_non_space               ; Loop until (A6) isn't ASCII value 32 (space)
	CMP.B   #$0D, D0                          ; Is it CR?
	BNE     go_help                           ; Jump if there were more parameters

	MOVE.L  (A7)+, A6                         ; Pop A6 from the stack
	MOVE.L  D1, D0
	BSR     dump_d0
	BRA     enter_language_rom                ; Check copyright message and ROM type and enter language ROM

; -----------------------------------------------------------------------------
; *GO Syntax error
; -----------------------------------------------------------------------------
go_help
	MOVE.L  #go_help_message, A6              ; Location of message in A0
	BSR     print_message
	MOVE.L  (A7)+, A6                         ; Pop A6 from the stack
	RTS

; -----------------------------------------------------------------------------
; *HELP
; -----------------------------------------------------------------------------
help
	MOVE.B  (A6)+, D0
	CMP.B   #$2E, D0                          ; Is it .?
	BEQ     help2
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #$45, D0                          ; Is it E?
	BNE     _oscli1
	MOVE.B  (A6)+, D0
	CMP.B   #$2E, D0                          ; Is it .?
	BEQ     help2
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #$4C, D0                          ; Is it L?
	BNE     _oscli1
	MOVE.B  (A6)+, D0
	CMP.B   #$2E, D0                          ; Is it .?
	BEQ     help2
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #$50, D0                          ; Is it P?
	BNE     _oscli1
help2
	BSR     find_next_non_space               ; Loop until (A6) isn't ASCII value 32 (space)
	MOVE.B  (A6)+, D0
	CMP.B   #$0D, D0                          ; Is it CR?
	BNE     help3
	MOVE.L  #help_message, A6                 ; Location of message in A6
	BSR     print_message
	BRA     _oscli1                           ; And pass the *HELP to the host
help3
	BRA     _oscli1

; -----------------------------------------------------------------------------
; *MON
; -----------------------------------------------------------------------------
mon
	MOVE.B  (A6)+, D0
	CMP.B   #'.', D0                          ; Is it .?
	BEQ     mon2
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #'O', D0                          ; Is it O?
	BNE     _oscli1
	MOVE.B  (A6)+, D0
	CMP.B   #'.', D0                          ; Is it .?
	BEQ     mon2
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #'N', D0                          ; Is it N?
	BNE     _oscli1
mon2
	BSR     find_next_non_space               ; Loop until (A6) isn't ASCII value 32 (space)
	CMP.B   #$0D, D0                          ; Is it CR?
	BNE     mon_help

	MOVE.L  #monitor_message, A6               ; Location of message in A0
	BSR     print_message

monitor_loop
	BSR     osnewl
	MOVE.B  #'>', D0                          ; > Prompt
	BSR     oswrch

	MOVE.L  #osword_00_parameterblock, A6     ; A6 points to OSWORD &00 parameter block
	MOVEQ   #$00, D0                          ; OSWORD &00: Read line from input
	BSR     osword
	BCC     monitor3                          ; Jump if user hasn't pressed ESCAPE
monitor_exit
	BSR     osnewl                            ; Print newline
	MOVE.L  (A7)+, A6                         ; Pop A6 from the stack
	RTS                                       ; Exit the monitor

monitor3
	MOVE.L  #buffer, A6                       ; A6 points to the line read by the OSWORD &00 call
	MOVE.B  (A6)+, D0
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #'Q', D0                          ; Is it Q?
	BEQ     monitor_exit

	CMP.B   #'H', D0                          ; Is it H?
	BNE     monitor4
	MOVE.L  #monitor_help_message, A6         ; Location of message in A0
	BSR     print_message
	BRA     monitor_loop

monitor4
	CMP.B   #'R', D0                          ; Is it R?
	BNE     monitor5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	MOVE.B  #'D', D0
	BSR     oswrch
	MOVE.B  #'0', D0
	BSR     oswrch
	MOVE.B  #':', D0
	BSR     oswrch
	BSR     dump_d0
	BSR     osnewl
	MOVE.L  #statusregister_message, A6       ; Location of message in A0
	BSR     print_message
	BSR     osnewl
	BSR     dump_sr
	BRA     monitor_loop

monitor5
	CMP.B   #'D', D0                          ; Is it D?
	BNE     monitor_loop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	BRA     monitor_loop

; -----------------------------------------------------------------------------
; *MON Syntax error
; -----------------------------------------------------------------------------
mon_help
	MOVE.L  #mon_help_message, A6             ; Location of message in A0
	BSR     print_message
	MOVE.L  (A7)+, A6                         ; Pop A6 from the stack
	RTS

; -----------------------------------------------------------------------------
; *S
; -----------------------------------------------------------------------------
s
	MOVE.B  (A6)+, D0                         ; Get the next character
	CMP.B   #$20, D0                          ; Is it SPACE?
	BNE     _oscli1
	BSR     find_next_non_space               ; Loop until (A6) isn't ASCII value 32 (space)
	BSR     get_hex_value                     ; Return hex value of string at (A6) in D1
	BCS     s_help                            ; Jump if the parameter wasn't valid
	BSR     find_next_non_space               ; Loop until (A6) isn't ASCII value 32 (space)
	CMP.B   #$0D, D0                          ; Is it CR?
	BNE     s_help                            ; Jump if there were more parameters
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	MOVE.L  (A7)+, A6                         ; Pop A6 from the stack
	RTS

; -----------------------------------------------------------------------------
; *S Syntax error
; -----------------------------------------------------------------------------
s_help
	MOVE.L  #s_help_message, A6               ; Location of message in A0
	BSR     print_message
	MOVE.L  (A7)+, A6                         ; Pop A6 from the stack
	RTS

; -----------------------------------------------------------------------------
; *XFER
; -----------------------------------------------------------------------------
xfer
	MOVE.B  (A6)+, D0
	CMP.B   #'.', D0                          ; Is it .?
	BEQ     xfer2
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #'X', D0                          ; Is it T?
	BNE     _oscli1
	MOVE.B  (A6)+, D0
	CMP.B   #'.', D0                          ; Is it .?
	BEQ     xfer2
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #'F', D0                          ; Is it F?
	BNE     _oscli1
	MOVE.B  (A6)+, D0
	CMP.B   #'.', D0                          ; Is it .?
	BEQ     xfer2
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #'E', D0                          ; Is it E?
	BNE     _oscli1
	MOVE.B  (A6)+, D0
	CMP.B   #'.', D0                          ; Is it .?
	BEQ     xfer2
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #'R', D0                          ; Is it R?
	BNE     _oscli1
	MOVE.B  (A6)+, D0                         ; Get the next character
	CMP.B   #' ', D0                          ; Is it SPACE?
	BNE     _oscli1
xfer2
	BSR     find_next_non_space               ; Loop until (A6) isn't ASCII value 32 (space)
	BSR     get_hex_value                     ; Return hex value of string at (A6) in D1
	BCS     xfer_help                         ; Jump if the parameter wasn't valid
	MOVE.L  D1, D7                            ; Move host address to D7

	BSR     find_next_non_space               ; Loop until (A6) isn't ASCII value 32 (space)
	BSR     get_hex_value                     ; Return hex value of string at (A6) in D1
	BCS     xfer_help                           ; Jump if the parameter wasn't valid
	MOVE.L  D1, D6                            ; Move parasite address to D6

	BSR     find_next_non_space               ; Loop until (A6) isn't ASCII value 32 (space)
	BSR     get_hex_value                     ; Return hex value of string at (A6) in D1
	BCS     xfer_help                           ; Jump if the parameter wasn't valid
	MOVE.L  D1, D5                            ; Move length to D5


	BSR     find_next_non_space               ; Loop until (A6) isn't ASCII value 32 (space)
	ANDI.B  #$DF, D0                          ; Make character upper-case
	CMP.B   #'R', D0                          ; Is it a R(ead)?
	BEQ     xfer3
	CMP.B   #'W', D0                          ; ...or a W(rite)?
	BNE     xfer_help

;debug stuff
	MOVE.B  D0, D4
	BSR oswrch
	MOVE    D7, D0
	BSR     dump_d0
	MOVE    D6, D0
	BSR     dump_d0
	MOVE    D5, D0
	BSR     dump_d0


xfer3
	BSR     find_next_non_space               ; Loop until (A6) isn't ASCII value 32 (space)
	CMP.B   #$0D, D0                          ; Is it CR?
	BNE     xfer_help                         ; Jump if there were more parameters

	CMP.B   #'W', D4
	BEQ     xfer_write
	                                          ; Read data from host
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	MOVE.L  (A7)+, A6                         ; Pop A6 from the stack
	RTS

xfer_write
	                                          ; Write data from host
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	MOVE.L  (A7)+, A6                         ; Pop A6 from the stack
	RTS

; -----------------------------------------------------------------------------
; *XFER Syntax error
; -----------------------------------------------------------------------------
xfer_help
	MOVE.L  #xfer_help_message, A6              ; Location of message in A0
	BSR     print_message
	MOVE.L  (A7)+, A6                         ; Pop A6 from the stack
	RTS

; -----------------------------------------------------------------------------
; Handler for not supported OS calls
; -----------------------------------------------------------------------------
not_supported
	MOVE.L  #not_supported_error, A6
	MOVEQ   #OS_GenerateError, D0
	TRAP    #14

; -----------------------------------------------------------------------------
; EVENT/IND1V/IND2V/IND3V handler
; -----------------------------------------------------------------------------
_evntv
_ind1v
_ind2v
_ind3v
	RTS

; -----------------------------------------------------------------------------
; IRQ1V handler
; -----------------------------------------------------------------------------
_irq1v
	RTS

; -----------------------------------------------------------------------------
; IRQ handler
; -----------------------------------------------------------------------------
irq_handler
	RTE

; -----------------------------------------------------------------------------
; NMI handler
; -----------------------------------------------------------------------------
nmi_handler
	RTE

; -----------------------------------------------------------------------------
; Unused interrupt handler
; -----------------------------------------------------------------------------
unknown_interrupt
	MOVE.L  A6, -(A7)                         ; Push A6 to the stack
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	MOVE.L  #unknowninterrupterror, A6        ; Location of message in A6
	BSR     print_message                     ; Print the message
	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	MOVE.L  (A7)+, A6                         ; Pull A6 from the stack
	RTE

; -----------------------------------------------------------------------------
; Find out how much RAM is available
; -----------------------------------------------------------------------------
findram
	MOVE.L  D0, -(A7)                         ; Push D0 to the stack
	MOVE.L  $00000000, -(A7)                  ; ...and save it on the stack
	MOVEQ   #$00, D0                          ; Reset counter
	MOVE.L  #$DEADBEEF, $00000000             ; Set $00000000 to the magic number
findram2
	ADDI.L  #$00000400, D0                    ; Increase counter with 1Kbyte
	MOVE.L  A0, D0
	CMPI.L  #$DEADBEEF, (A0)                  ; Is it the same as location $00000000?
	BNE     findram2                          ; No, then loop

	MOVE.L  D0, ramsize                       ; Store it in the OS workspace
	MOVE.L  (A7)+, $00000000                  ; Pull original contents of $00000000 from the stack
	MOVE.L  (A7)+, D0                         ; Pull D0 from the stack
	RTS	

; -----------------------------------------------------------------------------
; Print D0 register contents
; -----------------------------------------------------------------------------
dump_d0
;	MOVEM   D1-D4, -(A7)                      ; save used regs
	MOVE.L  D0, D1                            ; copy source
	MOVE.B  #$30, D4                          ; ASCII "0" for add
	MOVE.W  #$07, D2                          ; Nibbles to do

shift_wo
	ROL.L   #4, D1                            ; Top nibble to bottom
 	MOVE.B  D1, D0                            ; Copy it
	AND.B   #$0F, D0                          ; Mask the nibble
	MOVE.B  #$09, D3                          ; set compare value
 	SUB.B   D0, D3                            ; Set extend for +1 if >9
	ABCD    D4, D0                            ; Add '0' + extend

	BSR     oswrch                            ; Output byte
	DBF     D2, shift_wo                      ; Do next nibble

;	MOVEM.L (SP)+, D1-D4                      ; Restore used regs
	RTS

; -----------------------------------------------------------------------------
; Print status register contents
; -----------------------------------------------------------------------------
dump_sr
	MOVE.W  SR, D1                            ; Transfer status register contents to D0
	MOVEQ   #15, D2                           ; Status register is 16-bit wide
	MOVEQ   #0, D3                            ; Temp register needed for ABCD

dump_sr1
	MOVEQ   #$30, D0                          ; ASCII value of '0'
	ASL.L   #1, D1                            ; Shift leftmost bit into carry
	ABCD    D3, D0                            ; Add carry to ASCII value
	BSR     oswrch                            ; And print the bit
	DBF     D2, dump_sr1

	RTS

; -----------------------------------------------------------------------------
; Set interrupt level
; -----------------------------------------------------------------------------
set_interrupt
	ANDI.L  #$7, D0                           ; Mask out other bits
	ASL.W   #8, D0                            ; 

	MOVE.L  D1, -(A7)                         ; Push D1 to the stack
;	MOVE.C  CCR, D1                           ; Get current status register
        ANDI.W  #$F8FF,D1                         ; Mask out the ISR bits
        OR.W    D0, D1                            ; And set the interrupt level
;	MOVE.C  D1, CCR

	MOVE.L  (A7)+, D1                         ; Pull A6 from the stack
	RTS

; -----------------------------------------------------------------------------
; Set supervisor bit
; -----------------------------------------------------------------------------
set_supervisor_bit
	ORI.W   #$2000, SR
	RTS

; -----------------------------------------------------------------------------
; Clear supervisor bit
; -----------------------------------------------------------------------------
clear_supervisor_bit
	ANDI.W  #$DFFF, SR
	RTS

; -----------------------------------------------------------------------------
; Check CPU type ($01=68008, $02=68000, $03=68010, $04=68020, $05=68030, $06=68040, $07=68060, $FF=unknown CPU)
; -----------------------------------------------------------------------------
* this needs to be run at reset or else a way to get the vector base address needs to
* be known

check_cpu
      MOVEQ       #0,d0                   * exception vector base, assumes 68000 here
      MOVEA.l     d0,a5                   * point to vector base
      MOVEA.l     $0C(a5),a0              * save the address exception vector
      LEA         check_cpu2(pc),a1       * get the continue address
      MOVE.l      a1,$0C(a5)              * save as the address exception vector
      MOVE.l      sp,d7                   * copy the stack pointer
      MOVE.l      d7,d6                   * copy the stack pointer again
      JMP         *+5(pc)                 * cause an address error - all processors

* now there is an address error exception frame on the stack the processor type can be
* deduced from the size of this frame

check_cpu2
      MOVE.l      a0,$0C(a5)              * restore the address exception vector
      SUB.l       sp,d7                   * calculate the size of the stack frame

      MOVEQ       #$02,d0                 * default to 68000 processor
      CMPI.b      #$12,d7                 * compare frame size with that of 68000
      BEQ.s       proc_found              * if 68000 size then exit

      MOVEQ       #$03,d0                 * set 68010 processor
      CMPI.b      #$3E,d7                 * compare frame size with that of 68010
      BEQ.s       proc_found              * if 68010 size then exit

      MOVEQ       #$04,d0                 * set 68070 processor
      CMPI.b      #$26,d7                 * compare frame size with that of 68070
      BEQ.s       proc_found              * if 68070 size then exit

      MOVE.l      #$05,d0                 * set 68300 processor
      CMPI.b      #$1C,d7                 * compare frame size with that of 68300
      BEQ.s       proc_found              * if 68300 size then exit

      MOVEQ       #$06,d0                 * set 68040 processor
      CMPI.b      #$10,d7                 * compare frame size with that of 68040
      BEQ.s       proc_found              * if 68040 size then exit

      MOVEQ       #$FF,d0                 * set unknown processor
      CMPI.b      #$24,d7                 * compare frame size with that of 68020/030
      BNE.s       proc_found              * if not 68020/030 size then exit

* else test for 68020/68030

      MOVE.l      $1A(a5),a0              * get illegal instruction exception vector
      MOVE.l      $7E(a5),a1              * get format error exception vector

      LEA         is_68020(pc),a2         * set our format error exception vector
      MOVE.l      a2,$7E(a5)              * save format error exception vector

      LEA         is_68030(pc),a2         * set our illegal instruction exception vector
      MOVE.l      a2,$1A(a5)              * save illegal instruction exception vector
      MOVEQ       #$04,d0                 * default to 68020 processor

      dc.w        $06FA,$0000,$0002       * CALLM #0,next_word(pc)
                                          * call module, 68020 only
next_word
      dc.w        -1                      * dummy data, cause format error

* illegal instruction exception arrives here

is_68030
      MOVEQ       #$05,d0                 * set 68030 processor

* format error exception arrives here

is_68020
      MOVE.l      a1,$7E(a5)              * restore format error exception vector
      MOVE.l      a0,$1A(a5)              * restore illegal instruction exception vector
proc_found
      MOVE.l      d6,sp                   * restore the stack pointer
      RTS

; -----------------------------------------------------------------------------
; Check FPU type ($00=no FPU, $01=68881, $02=68882, $03=CPU integrated(68040/68060), $FF=unknown FPU)
; -----------------------------------------------------------------------------

check_fpu
	MOVEQ   #0,D0                   ; exception vector base, assumes 68000 here
	MOVEA.L D0,A5                   ; point to vector base
	MOVEA.L $2C(A5),A0              ; save the address exception vector
	LEA     no_fpu(pc),A1           ; get the continue address
	MOVE.L  A1,$2C(A5)              ; save as the address exception vector
	MOVE.L  SP,D7                   ; copy the stack pointer

;	FMOVE.S #0,FP0                  ; FPU instruction; if no FPU is available, an exception $10 will be generated

	MOVEQ   #$FF, D0                ; Set FPU flag
	BRA     check_fpu2

no_fpu
	MOVEQ   #$FF, D0                ; Set FPU flag

check_fpu2
	MOVE.L  D7,SP                   ; restore the stack pointer
	MOVE.L  A0,$2C(A5)              ; save as the address exception vector
	RTS

; -----------------------------------------------------------------------------
; MMU type ($00=no MMU, $01=68841, $02=68851, $03=CPU integrated(68030/68040/68060), $FF=unknown MMU)
; -----------------------------------------------------------------------------
check_mmu
	MOVEQ   #$00, D0
	RTS

; -----------------------------------------------------------------------------

; -----------------------------------------------------------------------------
; Strings
; -----------------------------------------------------------------------------
startup_message
	DC.B   $0A
	DC.B   'Acorn 68030 second processor 512K', $0A, $0A, $0D, $00

help_message
	DC.B   $0A
	DC.B   $0D
	DC.B   '68030 TUBE 0.10', $0A, $0D
	DC.B   '   FLASH <sector> <addr>', $0A, $0D
	DC.B   '   GO <addr>', $0A, $0D
	DC.B   '   MON', $0A, $0D
	DC.B   '   S <addr>', $0A, $0D
	DC.B   '   SR <start addr> <end start> <"string">', $0A, $0D
	DC.B   '   XFER <io addr.> <addr> <length> <r>|<w>', $0A, $0D, $00

flash_help_message
	DC.B   'Syntax : FLASH <sector> <addr>', $0A, $0D, $00

go_help_message
	DC.B   'Syntax : GO <addr>', $0A, $0D, $00

mon_help_message
	DC.B   'Syntax : MON', $0A, $0D, $00

s_help_message
	DC.B   'Syntax : S <addr>', $0A, $0D, $00

sr_help_message
	DC.B   'Syntax : SR <start addr> <end start> <"string">', $0A, $0D, $00

xfer_help_message
	DC.B   'Syntax : XFER <io addr.> <addr> <length> <r>|<w>', $0A, $0D, $00

monitor_message
	DC.B   '680x0 Monitor', $00

monitor_help_message
	DC.B   'D  Dump memory', $0A, $0D
	DC.B   'F  Fill <start addr> <end addr> <fill byte|word|long>', $0A, $0D
	DC.B   'G  Go', $0A, $0D
	DC.B   'H  Help', $0A, $0D
	DC.B   'L  Load', $0A, $0D
	DC.B   'Q  Quit', $0A, $0D
	DC.B   'R  Set register contents', $0A, $0D
	DC.B   'S  Save', $0A, $0D
	DC.B   'T  Trace', $0A, $0D
	DC.B   'V  View register contents', $0A, $0D, $00

;	                                                              T S  INT   XNZVC
;	 D0 = 00000000 D4 = 00000000 A0 = 00000000 A4 = 00000000 SR = 0000000000000000
;	 D1 = 00000000 D5 = 00000000 A1 = 00000000 A5 = 00000000 US = 00000000
;	 D2 = 00000000 D6 = 00000000 A2 = 00000000 A6 = 00000000 SS = 000007FC
;	 D3 = 00000000 D7 = 00000000 A3 = 00000000 A7 = 00000000 PC = 00000000

statusregister_message
	DC.B   'T-S--INT---XNZVC', $00

swi_not_known_message
	DC.B   'SWI not known', $00

unknowninterrupterror
	DC.B   $FF
	DC.B   'Unknown interrupt', $00

not_a_language_error
	DC.B   $FF
	DC.B   'This is not a language', $00

cannot_run_code_error
	DC.B   $FF
	DC.B   'I cannot run this code', $00

escape_error
	DC.B   $11
	DC.B   'Escape', $00

not_supported_error
	DC.B   $FF
	DC.B   'Not supported', $00

flash_warning
	DC.B   'WARNING! THIS WILL FLASH THE BIOS', $0A, $0D
	DC.B   'USE AT YOUR OWN RISK!', $0A, $0D, $0A, $0D
	DC.B   'Do you want to continue? (Y/N) : ', $00

flash_identify_message
	DC.B   'Flash ROM  ID=$', $00

flash_start_message
	DC.B   $0A, $0D
	DC.B   'Flashing sector ', $0A, $0D, $00

flash_finish_message
	DC.B   'Flash completed successfully', $0A, $0D, $00

flash_error_message
	DC.B   'Flash error at ', $00

; -----------------------------------------------------------------------------
; Table which specifies OSWORD call parameter block length
; -----------------------------------------------------------------------------
osword_send_table
	                                          ; Length of parameterblock to be send to the host processor
	DC.B   $00                                ; OSWORD $01: Parameter block length = $00
	DC.B   $05                                ; OSWORD $02: Parameter block length = $05
	DC.B   $00                                ; OSWORD $03: Parameter block length = $00
	DC.B   $05                                ; OSWORD $04: Parameter block length = $05
	DC.B   $02                                ; OSWORD $05: Parameter block length = $02
	DC.B   $05                                ; OSWORD $06: Parameter block length = $05
	DC.B   $08                                ; OSWORD $07: Parameter block length = $08
	DC.B   $0E                                ; OSWORD $08: Parameter block length = $0E
	DC.B   $04                                ; OSWORD $09: Parameter block length = $04
	DC.B   $01                                ; OSWORD $0A: Parameter block length = $01
	DC.B   $01                                ; OSWORD $0B: Parameter block length = $01
	DC.B   $05                                ; OSWORD $0C: Parameter block length = $05
	DC.B   $00                                ; OSWORD $0D: Parameter block length = $00
	DC.B   $01                                ; OSWORD $0E: Parameter block length = $01
	DC.B   $20                                ; OSWORD $0F: Parameter block length = $20
	DC.B   $10                                ; OSWORD &10: Parameter block length = &10
	DC.B   $0D                                ; OSWORD &11: Parameter block length = &0D
	DC.B   $00                                ; OSWORD &12: Parameter block length = &00
	DC.B   $04                                ; OSWORD &13: Parameter block length = &04
	DC.B   $80                                ; OSWORD &14: Parameter block length = &80

osword_recv_table
	                                          ; Length of parameterblock to be received from the host processor
	DC.B   $05                                ; OSWORD &01: Parameter block length = &05
	DC.B   $00                                ; OSWORD &02: Parameter block length = &00
	DC.B   $05                                ; OSWORD &03: Parameter block length = &05
	DC.B   $00                                ; OSWORD &04: Parameter block length = &00
	DC.B   $05                                ; OSWORD &05: Parameter block length = &05
	DC.B   $00                                ; OSWORD &06: Parameter block length = &00
	DC.B   $00                                ; OSWORD &07: Parameter block length = &00
	DC.B   $00                                ; OSWORD &08: Parameter block length = &00
	DC.B   $05                                ; OSWORD &09: Parameter block length = &05
	DC.B   $09                                ; OSWORD &0A: Parameter block length = &09
	DC.B   $05                                ; OSWORD &0B: Parameter block length = &05
	DC.B   $00                                ; OSWORD &0C: Parameter block length = &00
	DC.B   $08                                ; OSWORD &0D: Parameter block length = &08
	DC.B   $18                                ; OSWORD &0E: Parameter block length = &18
	DC.B   $00                                ; OSWORD &0F: Parameter block length = &00
	DC.B   $01                                ; OSWORD &10: Parameter block length = &01
	DC.B   $0D                                ; OSWORD &11: Parameter block length = &0D
	DC.B   $80                                ; OSWORD &12: Parameter block length = &80
	DC.B   $04                                ; OSWORD &13: Parameter block length = &04
	DC.B   $80                                ; OSWORD &14: Parameter block length = &80

; -----------------------------------------------------------------------------
; Jump table
; -----------------------------------------------------------------------------

	ORG $00007F7C

osrdrm
	JMP    not_supported

vduchr
	JMP    not_supported

oseven
	JMP    not_supported

gsinit
	JMP    not_supported

gsread
	JMP    not_supported

nvrdch
	JMP    _osrdch

nvwrch
	JMP    _oswrch

osfind
	MOVE.L (findv).L, -(A7)                   ; Push FINDV to the stack
	RTS

osgbpb
	MOVE.L (gbpbv).L, -(A7)                   ; Push GBPBV to the stack
	RTS

osbput
	MOVE.L (bputv).L, -(A7)                   ; Push BPUTV to the stack
	RTS

osbget
	MOVE.L (bgetv).L, -(A7)                   ; Push BGETV to the stack
	RTS

osargs
	MOVE.L (argsv).L, -(A7)                   ; Push ARGSV to the stack
	RTS

osfile
	MOVE.L (filev).L, -(A7)                   ; Push FILEV to the stack
	RTS

osrdch
	MOVE.L (rdchv).L, -(A7)                   ; Push RDCHV to the stack
	RTS

osasci
	CMP.B   #$0D, D0
	BNE     oswrch

osnewl
	MOVEQ   #$0A, D0
	BSR     oswrch	
	MOVEQ   #$0D, D0

oswrch
	MOVE.L (wrchv).L, -(A7)                   ; Push WRCHV to the stack
	RTS

osword
	MOVE.L (wordv).L, -(A7)                   ; Push WORDV to the stack
	RTS

osbyte
	MOVE.L (bytev).L, -(A7)                   ; Push BYTEV to the stack
	RTS

oscli
	MOVE.L (cliv).L, -(A7)                    ; Push CLIV to the stack
	RTS

	END START
